<template>
  <div class="info row">
    <div class="view-info col-sm-12 col-lg-6">
      <div>
        <ul v-if="editUser">
          <div class="single-line-input">
            <div class="form-group">
              <label for="name">ИМЯ</label>
              <input type="text" class="main-input" :class="{'invalid': checkRequired(editUser.firstName)}" v-model="editUser.firstName" name="firstName">
            </div>

            <div class="form-group">
              <label for="name">ФАМИЛИЯ</label>
              <input type="text" class="main-input" :class="{'invalid': checkRequired(editUser.lastName)}" v-model="editUser.lastName" name="lastName">
            </div>
          </div>
          <div class="form-group">
            <label for="email">EMAIL</label>
            <div>
              <input type="text" class="main-input" :class="{'invalid': checkRequired(editUser.email, 'email')}" v-model="editUser.email" name="email">
            </div>
          </div>
          

          <div class="form-group">
            <label for="name">ТЕЛЕФОН</label>
            <div class="d-flex">
              <span class="phone-code">+380 </span>
              <input type="text" class="main-input mt-1" :class="{'invalid': checkRequired(editUser.phone, 'phone')}" v-model="editUser.phone" name="phone">
            </div>
          </div>
        </ul>
        <p @click="showChangePassword = !showChangePassword;" class="change-pw-btn">Изменить Пароль</p>

        <div class="password-change-form" v-show="showChangePassword">
          <div class="form-group">
            <label for="oldPassword">СТАРЫЙ ПАРОЛЬ</label>
            <input type="password" class="main-input" :class="{'invalid': checkRequired(passwordChange.oldPassword)}" v-model="passwordChange.oldPassword" name="oldPassword" autocomplete="new-password">
          </div>

          <div class="form-group">
            <label for="password">НОВЫЙ ПАРОЛЬ</label>
            <input type="password" class="main-input" :class="{'invalid': checkRequired(passwordChange.password)}" v-model="passwordChange.password" name="password" autocomplete="new-password">
          </div>

          <div class="form-group">
            <label for="password">ПОДТВЕРЖДЕНИЕ ПАРОЛЯ</label>
            <input type="password" class="main-input" :class="{'invalid': checkRequired(passwordChange.passwordConfirm)}" v-model="passwordChange.passwordConfirm" name="passwordConfirm" autocomplete="new-password">
          </div>
        </div>
      </div>
      <p class="errorMessage" v-if="error" v-text="error"></p>
      <button class="action-button black-button" @click="saveChanges">СОХРАНИТЬ</button>
    </div>

    <div class="profile-add col-sm-12 col-lg-6 widget-newsletter" >
      <div class="pr-add-container">
        <div class="promo-capture mb-2">
          <p class="text-center"> - 10% НА ВСЕ С КОДОМ  <span class="promo-code">SAVE20</span></p>
          <p>Спасибо, что вы с нами <i class="fa fa-heart"></i></p>
        </div>

        <div class="newsletter-box">
          <div class="newsletter-wrapper">
            <h4>ПОДПИСАТЬСЯ НА EMAIL РАССЫЛКУ</h4>
            <p>Будьте в курсе новых тредов и наших поступлений</p>
            <form>
              <input type="text" class="form-control" placeholder="Ваш email адрес" />
              <input class="action-button gray-button" type="submit" value="ПОДПИСАТЬСЯ" />
            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapMutations } from "vuex";
import {
  getLoggedInUser
} from "@/components/shared/service/authService";

export default {
  data() {
    return {
      error: '',
      currentUser: undefined, editUser: undefined,
      showChangePassword: false,
      passwordChange: {
        'oldPassword': '',
        'password': '',
        'passwordConfirm': ''
      }
    }
  },
  methods: {
    ...mapMutations(["ADD_LOGGED_USER"]),
    checkRequired, saveChanges
  },
  mounted() {
    this.currentUser = getLoggedInUser();
    this.editUser = JSON.parse(JSON.stringify(this.currentUser));
  }
}

function saveChanges(e) {
  let self = this;
  self.showRequired = false;
  if (!self.editUser.firstName || !self.editUser.lastName || !self.editUser.phone || !self.editUser.email) {
    self.showRequired = true;
    return self.error = 'Please, fill in required fields';
  } else if (!validEmail(self.editUser.email)) {
    self.error = 'Please, provide a valid email address';
    return self.showRequired = true;
  } else if (!validPhone(self.editUser.phone)) {
    self.error = 'Please, provide a valid phone number';
    return self.showRequired = true;
  } else {
    if (!self.showChangePassword) {
      self.error = '';
      self.showRequired = false;
      return submitChanges(self.editUser);
    } else {
      if (!self.passwordChange.oldPassword || !self.passwordChange.password || !self.passwordChange.passwordConfirm) {
        self.showRequired = true;
        return self.error = 'Please, fill in required fields';
      } else if (self.passwordChange.password.length < 4) {
        self.showRequired = true;
        return self.error = 'New Password should be at least 4 characters long';
      } else if (self.passwordChange.password !== self.passwordChange.passwordConfirm) {
        self.showRequired = true;
        return self.error = 'New Password and Password Confirm should match';
      } else {
        self.error = '';
        self.showRequired = false;
        self.editUser.passwordChange = self.passwordChange;
        return submitChanges(self.editUser);
      }
    }
  }

  function submitChanges(editUser) {
    e.target.disabled = true;
    return self.$http.put(`${process.env.VUE_APP_BASE_URL}/edit-user`, editUser).then((resp) => {
      e.target.disabled = false;
      self.ADD_LOGGED_USER(resp.data);
    }).catch(err => {
      e.target.disabled = false;
      if (self.showChangePassword && err.response.status === 401) {
        self.error = 'Old Password is incorrect';
      } else {
        self.error = 'An Error Occured';
      }
    });
  }
}

function checkRequired(i, type) {
  if (type === 'email') {
    return this.showRequired && !i || this.showRequired && !validEmail(i);
  } else if (type === 'phone') {
    return this.showRequired && !i || this.showRequired && !validPhone(i);
  } else {
    return this.showRequired && !i;
  }
}
function validEmail(email) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(String(email).toLowerCase());
}

function validPhone(num) {
  num = num.toString();
  let m = num.match(/\d/g); 
  
  return m && num.length === 9;
}
</script>
<style lang="scss">
  .info {
    .phone-code {
      min-width: 50px !important;
    }
    .promo-capture {
      max-height: 180px;
    }
    .view-info {
      display: flex;
      flex-direction: column;
      justify-content: space-between;
      li {
        margin-bottom: 10px;
      }
      span {
        min-width: 160px;
        display: inline-block;
      }
      label {
        font-size: 14px;
        letter-spacing: 1.2px;
        color: gray;
      }
    }
    input {
      display: inline-block;
      margin-top: 3px !important;
    }

    .change-pw-btn {
      color: #5252e4;
      cursor: pointer;
      display: inline-block;
      font-style: italic;
      font-size: 14px;
      &:hover {
        text-decoration: underline;
      }
    }
    .password-change-form {
      margin-bottom: 15px;
      .form-group {
        margin-bottom: 0;
      }
    }

    .profile-add {
      height: 100%;
      width: 100%;
      position: relative;

      
      .pr-add-container {
        margin: 35px 25px 0;
        display: flex;
        flex-direction: column;
        justify-content: flex-end;

        .newsletter-box {
          padding: 0;
        }
        .newsletter-wrapper {
          text-align: center;
          padding: 10px;
          background-color: #ede8d7;
        }
      }
    }
  }
</style>